﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Demo06_BinaryFormatter
{
    [Serializable]
    public class CustomerSerialize
    {
        public string Name { get; set; }
        //二进制序列化会把所有的属性字段都序列化，包括私有private，
        //如果不想序列化，使用特性[NonSerialized]
        private string _desc { get; set; }
        public int _Age;
        [NonSerialized]
        private bool _sex;
        public CustomerSerialize(string name, string desc, int age, bool sex)
        {
            this.Name = name;
            this._desc = desc;
            this._Age = age;
            this._sex = sex;
        }
        [OnSerializing] //序列化的时候执行
        public void OnSerializingMothed(StreamingContext context)
        {
            Console.WriteLine("序列化的时候执行");
        }
        [OnSerialized]  //序列化完成后执行
        public void OnSerializedMothed(StreamingContext context)
        {
            Console.WriteLine("序列化完成后执行");
        }
        [OnDeserializing]   //反序列化的时候执行
        public void OnDeserializingMothed(StreamingContext context)
        {
            Console.WriteLine("反序列化的时候执行");
        }
        [OnDeserialized]    //反序列化完成执行
        public void OnDeserializedMothed(StreamingContext context)
        {
            Console.WriteLine("反序列化完成执行");
        }
    }
}
