﻿using System;
using System.IO;
using System.Text.Json;

namespace Demo06_JsonSerializer
{
    internal class Program
    {
        static void Main(string[] args)
        {
            //JSON序列化
            SerializeObject serializeObject = new SerializeObject("BigBox777", 18, true);
            using (TextWriter tw = new StreamWriter("JsonSerializer.json"))
            {
                //将 JsonSerializerOptions.WriteIndented 设置为 true，以 JSON 进行优质打印
                //（包含缩进和空格，以提高可读性）。 对于生产用途，通常对于此设置会接受
                //默认值 false。
                JsonSerializerOptions jsonSerializerOptions = new JsonSerializerOptions();
                jsonSerializerOptions.WriteIndented = true;
                string jsonStr = JsonSerializer.Serialize<SerializeObject>(serializeObject, jsonSerializerOptions);
                tw.Write(jsonStr);
                Console.WriteLine(jsonStr);
            }

            ////JSON反序列化
            //using (TextReader tr=new StreamReader("JsonSerializer.json"))
            //{
            //    SerializeObject serializeObject1 = JsonSerializer.Deserialize<SerializeObject>(tr.ReadToEnd());
            //}

            Console.ReadLine();
        }
    }
}
